import processing.net.*;

import processing.net.*;

import processing.net.*;

/**
 * (./) udp.pde - how to use UDP library as unicast connection
 * (cc) 2006, Cousot stephane for The Atelier Hypermedia
 * (->) http://hypermedia.loeil.org/processing/
 *
 * Create a communication between Processing<->Pure Data @ http://puredata.info/
 * This program also requires to run a small program on Pd to exchange data  
 * (hum!!! for a complete experimentation), you can find the related Pd patch
 * at http://hypermedia.loeil.org/processing/udp.pd
 * 
 * -- note that all Pd input/output messages are completed with the characters 
 * ";\n". Don't refer to this notation for a normal use. --
 */

// import UDP library
import hypermedia.net.*;

UDP udp;  // define the UDP object

  float [] dt;
  int b1=150, b2=300, b3=450;
  int e=0;
  PrintWriter outfile;
  float ms0, ms, mst;

/**
 * init
 */
void setup() {

  size( 600, 600 );
  background( #ffffff );
  
  // create a new datagram connection on port 10000
  // and wait for incomming message
  udp = new UDP( this, 10000 );
  //udp.log( true );     // <-- printout the connection activity
  udp.listen( true );
      
  PFont font = loadFont("MS-Mincho-16.vlw");
  textFont(font); 
  fill(0);
  text("2", 80,50);
  text("0", 80, 100) ;
  text("-2", 80, 150);
  text("ax", 30, 100);
  line(130, 50, 130, 150 );
  line( 130, 50, 135, 50);
  line( 130, 100, 135, 100);
  line( 130, 150, 135, 150);
    
  text("2", 80, 200);
  text("0", 80, 250) ;
  text("-2", 80, 300);
  text("ay", 30, 250);
  line( 130, 200, 130, 300 );
  line( 130, 200, 135, 200);
  line( 130, 250, 135, 250);
  line( 130, 300, 135, 300);
    
  text("2", 80,350);
  text("0", 80, 400) ;
  text("-2", 80, 450);
  text("az", 30, 400);
  line(130, 350, 130, 450 );
  line( 130, 350, 135, 350);
  line( 130, 400, 135, 400);
  line( 130, 450, 135, 450);
  
  line( 150, 20, 150, 40 );
  line( 283, 20, 283, 40 );
  line( 416, 20, 416, 40 );
  line( 549, 20, 549, 40 );

}

//process events
void draw() {
      
    int  a1=0, a2=0, a3=0;
  
    copy(151,50,500,100,150,50,500,100);
    a1=(int)((dt[1]+2)*100.0/4);
    if(a1<=0){ a1=1; }
    if(a1>100){ a1=100; }
    line(550,150-a1,549,b1);
    // point(550,150-a1);
    b1=150-a1;
    
    copy(151,200,500,100,150,200,500,100);
    a2=(int)((dt[2]+2)*100.0/4);
    if(a2<=0){ a2=1; }
    if(a2>100){ a2=100; } 
    line(550,300-a2,549,b2);
    // point(550,300-a2);
    b2=300-a2;
    
    copy(151,350,500,100,150,350,500,100);
    a3=(int)((dt[3]+2)*100.0/4);
    if(a3<=0){ a3=1; }
    if(a3>100){ a3=100; }
    line(550,450-a3,549,b3);
    // point(550,450-a3);
    b3=450-a3;
    
    if ((keyPressed == true) && (key == 's')) {
        e=1; 
        outfile = createWriter("out.txt");
        ms0 = millis();
    }
    if ((keyPressed == true) && (key == 'q')) { 
        e=0;
        outfile.close();
      }
    
    if(e==1){
        mst = ms - ms0;
        outfile.println(str(mst) + "," + str(dt[0]) + "," + str(dt[1])
                + "," + str(dt[2])+","+str(dt[3]) + "," + str(dt[4])
                + "," + str(dt[5]) + "," + str(dt[6]) + "," + str(dt[7])
                + "," + str(dt[8]) + "," + str(dt[9]) + "," + str(dt[10]) + "," + str(dt[11]) + "," + str(dt[12]) + "," + str(dt[13]));
    }  

}

/**
 * To perform any action on datagram reception, you need to implement this 
 * handler in your code. This method will be automatically called by the UDP 
 * object each time he receive a nonnull message.
 * By default, this method have just one argument (the received message as 
 * byte[] array), but in addition, two arguments (representing in order the 
 * sender IP address and his port) can be set like below.
 */
// void receive( byte[] data ) {       // <-- default handler
void receive( byte[] data, String ip, int port ) {  // <-- extended handler
  // get the "real" message =
  // forget the ";\n" at the end <-- !!! only for a communication with Pd !!!
  data = subset(data, 0, data.length-2);
  ms = millis();
  String message = new String( data );
  dt = float(split(message, ","));
   
  // print the result
  println( "receive: \""+message+"\" from "+ip+" on port "+port );
  print(ms+" "+dt[0]+" "+dt[1]+" "+dt[2]+" "+dt[3]+" "+dt[4]
            +" "+dt[5]+" "+dt[6]+" "+dt[7]+" "+dt[8]);
             
}
